# Server documentation

## Installation
For simple use and installation, the server services are empacted into a docker-compose. There will be containers for:
- mosquitto (MQTT broker)
- Nodered (No code web based programming tool)

> The first 2 steps can be skipped if you're using an other server and dont need to install raspbian and docker. (You'll only need docker, docker-compose ) 

### Install raspbian on the PI
We need to install a linux on the PI.

Download the Raspberry PI Imager on [https://www.raspberrypi.com/software/](https://www.raspberrypi.com/software/)


- Select the base raspbian image or similar (needs to be debian based for the exact commands to work)
- Select your SD card
- Configure Wifi and ssh for simpler use (Click on the bot right gear)
- Write


![installer.png](installer.png)



### Install Docker and docker compose on the PI
Source : [https://docs.docker.com/engine/install/raspbian/](https://docs.docker.com/engine/install/raspbian/)


```bash
sudo apt-get update
sudo apt-get install ca-certificates curl gnupg

sudo install -m 0755 -d /etc/apt/keyrings
curl -fsSL https://download.docker.com/linux/raspbian/gpg | sudo gpg --dearmor -o /etc/apt/keyrings/docker.gpg
sudo chmod a+r /etc/apt/keyrings/docker.gpg

echo \
  "deb [arch="$(dpkg --print-architecture)" signed-by=/etc/apt/keyrings/docker.gpg] https://download.docker.com/linux/raspbian \
  "$(. /etc/os-release && echo "$VERSION_CODENAME")" stable" | \
  sudo tee /etc/apt/sources.list.d/docker.list > /dev/null


sudo apt-get install docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin
sudo systemctl enable docker
```

Test the installation :
```bash
sudo docker run hello-world
```



### Install and run

Go into the server directory, you should have this file structure:
```bash
├── docker-compose.yml
├── mosquitto
│   └── config
│       └── mosquitto.conf
├── nodered
│   └── data
│       ├── flows.json
│       ├── flows_cred.json
│       ├── lib
│       │   └── flows
│       ├── node_modules
│       ├── package.json
│       └── settings.js
└── readme.md
```

Run the following command to start the server:
```bash
docker-compose up -d
```

Restart the server:
```bash
docker-compose restart
```

Stop the server:
```bash
docker-compose down
```

Get into the container's shell:
```bash
docker exec -it server bash
```